--------------------------------------------------------------------------------
--                  Pruebas a los SP en 02_SP_Documento.sql                   --
--------------------------------------------------------------------------------




-- Pruebas en la tabla documento

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
         
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
         
        RAISE NOTICE 'Prueba __alta_documento "Documento 1" incorrecta, no se envía el descriptor';
        SELECT general_accc.__alta_documento (1, 'ES.ACCC//1-1-1', 'Documento 1', 'Siglo XIX', 'Texto', 'Papel', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
                  
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
         
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba __alta_documento "Documento 1" incorrecta, nivel de descripción incoherente al tipo de documento';
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;
        SELECT general_accc.__alta_documento (1, 'ES.ACCC//1-1-1', 'Documento 1', 'Siglo XIX', 'Colección', 'No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
                  
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
         
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';    
        RAISE NOTICE 'Prueba __alta_documento "Documento 1" correcta';
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;
        SELECT general_accc.__alta_documento (1, 'ES.ACCC//1-1-1', 'Documento 1', 'Siglo XIX', 'Texto', 'Papel', 'Aula de Cultura del Carnaval de Cádiz', 'A1', null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, true, null) INTO salida;
        RAISE NOTICE '%', salida;

         
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba __modifica_documento correcta, el identificador fue dado';
        SELECT general_accc.__modifica_documento (1, null, 'Documento 1 modificado', null, null, null, null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, 'Donación', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO auxChar1 FROM general_accc.documento WHERE id = 1;
        RAISE NOTICE 'Valor actual del registro con id 1: ';
        RAISE NOTICE '    "%"', auxChar1;    
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
         
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba __modifica_documento. Error por falta de información de ubicación física';
        SELECT general_accc.__modifica_documento (1, null, null, null, null, null, '', '', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, true, null) INTO salida;
        RAISE NOTICE '%', salida;                  
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
         
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';    
        RAISE NOTICE 'Prueba __modifica_documento. Correcto con información de ubicación electrónica';
        SELECT general_accc.__modifica_documento (1, null, null, null, null, null, '', '', null, '/DatosACCC/Documentos/1.pdf', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, true, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO auxChar1 FROM general_accc.documento WHERE id = 1;
        RAISE NOTICE 'Valor actual del registro con id 1: ';
        RAISE NOTICE '    "%"', auxChar1;
                  
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
         
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';    
        RAISE NOTICE 'Prueba __baja_documento';
        SELECT general_accc.__baja_documento (1) INTO salida;
        RAISE NOTICE '%', salida;
                  
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
         
        RAISE NOTICE '    Se retira el hecho de tenerlo en déposito';
        SELECT general_accc.__modifica_documento (1, null, 'Documento 1 modificado', null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        RAISE NOTICE '    %', salida;
        RAISE NOTICE '    Se procede a la baja';
        SELECT general_accc.__baja_documento (1) INTO salida;
        RAISE NOTICE '    %', salida;          
                  
    END;
    $$;



-- Función añadida

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
         
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';    
        RAISE NOTICE 'Prueba modifica_id_documento ';
        SELECT id INTO auxInt1 FROM general_accc.documento LIMIT 1;       
        SELECT general_accc.modifica_id_documento (1, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO auxChar1 FROM general_accc.documento WHERE id = 1;
        RAISE NOTICE 'Valor actual del registro con id %: ', auxInt1;
        RAISE NOTICE '    "%"', auxChar1;

        -- devolver estado anterior
        SELECT general_accc.modifica_id_documento (auxInt1, 1) INTO salida;
         
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba __modifica_documento. Error por identificador incorrecto';
        SELECT id INTO auxInt1 FROM general_accc.documento LIMIT 1;       
        SELECT general_accc.modifica_id_documento (auxInt1, 999999) INTO salida;
        RAISE NOTICE '%', salida;                  
    END;
    $$;



-- Pruebas en tabla deposito_legal

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
         
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;
        SELECT general_accc.__alta_documento (1, 'ES.ACCC//1-1-1', 'Documento 1', 'Siglo XIX', 'Texto', 'No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE 'Creado documento de prueba: %', salida;
                  
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        RAISE NOTICE 'Prueba alta_depositolegal_documento incorrecta, sin documento tangible identificado';         
        SELECT general_accc.alta_depositolegal_documento (1, '2017-94885-2', null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
                  
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN         
        
        RAISE NOTICE ' ';
        SELECT general_accc.__modifica_documento (1, null, null, null, null, 'Papel', 'Aula de Cultura del Carnaval de Cádiz', 'A1', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, true, null) INTO salida;
        RAISE NOTICE 'Modificado documento de prueba: %', salida;
        
        RAISE NOTICE ' ';
        RAISE NOTICE '    Prueba alta_depositolegal_documento correcta, incluido información de posesión del documento';
        SELECT general_accc.alta_depositolegal_documento (1, '2017-94885-2', null, null, null) INTO salida;
        RAISE NOTICE '    %', salida;

         
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        SELECT id FROM general_accc.deposito_legal WHERE deposito_legal = '2017-94885-2' INTO auxInt1;
        
        RAISE NOTICE 'Prueba modifica_depositolegal_documento correcta';
        SELECT general_accc.modifica_depositolegal_documento (auxInt1, 1, '2017-3452-1', '6ª', null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT deposito_legal INTO auxChar1 FROM general_accc.deposito_legal WHERE id = auxInt1;
        RAISE NOTICE 'Valor actual del registro con id %: ', auxInt1;
        RAISE NOTICE '    "%"', auxChar1;    
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN         
        
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba alta_depositolegal_documento correcta, segundo registro';
        SELECT general_accc.alta_depositolegal_documento (1, '2017-94885-2', null, null, 'Editorial') INTO salida;
        RAISE NOTICE '%', salida;  
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
    
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba alta_depositolegal_documento incorrecta, duplicado';
        SELECT general_accc.alta_depositolegal_documento (1, '2017-3452-1', null, null, 'Editorial') INTO salida;
        RAISE NOTICE '%', salida;  
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_depositolegal_documento correcta';
        SELECT id INTO auxInt1 FROM general_accc.deposito_legal WHERE deposito_legal = '2017-3452-1';
        SELECT general_accc.baja_depositolegal_documento (auxInt1, 1) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;


-- Pruebas sobre la tabla descriptor_documento

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_descriptor_documento correcta';
        SELECT id INTO auxInt1
            FROM general_accc.descriptor
            WHERE id NOT IN (SELECT descriptor
                             FROM general_accc.descriptor_documento
                             WHERE documento = 1)
            LIMIT 1;
        SELECT general_accc.alta_descriptor_documento (auxInt1, 1) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_descriptor_documento correcta';
        
        SELECT id INTO auxInt1
            FROM general_accc.descriptor
            WHERE id NOT IN (SELECT descriptor
                             FROM general_accc.descriptor_documento
                             WHERE documento = 1)
            ORDER BY id DESC
            LIMIT 1;
            
        SELECT general_accc.alta_descriptor_documento (auxInt1, 1) INTO salida;
        RAISE NOTICE '%', salida;

        
        RAISE NOTICE 'Prueba modifica_descriptor_documento correcta';
        SELECT id INTO auxInt1
            FROM general_accc.descriptor_documento
            WHERE documento = 1;
                             
        SELECT id INTO auxInt2
            FROM general_accc.descriptor
            WHERE id NOT IN (SELECT descriptor
                             FROM general_accc.descriptor_documento
                             WHERE documento = 1)
            ORDER BY id ASC
            LIMIT 1;
            
        SELECT general_accc.modifica_descriptor_documento (auxInt1, auxInt2, 1) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_descriptor_documento incorrecta, duplicado';
        
        SELECT descriptor INTO auxInt1 FROM general_accc.descriptor_documento WHERE documento = 1 LIMIT 1;
            
        SELECT general_accc.alta_descriptor_documento (auxInt1, 1) INTO salida;
        RAISE NOTICE '%', salida;

    END;
    $$;

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_descriptor_documento incorrecta, cambiar el documento';
        
        SELECT id, descriptor, documento INTO auxInt1, auxInt2, auxInt3
            FROM general_accc.descriptor_documento
            WHERE documento = 1 LIMIT 1;

        SELECT id INTO auxInt3
            FROM general_accc.documento
            WHERE id <> 1 LIMIT 1;
            
        SELECT general_accc.modifica_descriptor_documento (auxInt1, auxInt2, auxInt3) INTO salida;
        RAISE NOTICE '%', salida;

    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_descriptor_documento completa, falla en el último';
        
        FOR auxRecord IN (SELECT id, descriptor, documento 
                              FROM general_accc.descriptor_documento
                              WHERE documento = 1)
        LOOP
            
            SELECT general_accc.baja_descriptor_documento (auxRecord.id, auxRecord.descriptor, auxRecord.documento) INTO salida;
            RAISE NOTICE '%', salida;
        END LOOP;

    END;
    $$;
    


-- Baja al documento de pruebas
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        SELECT general_accc.__modifica_documento (1, null, 'Documento 1 modificado', null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        SELECT general_accc.__baja_documento (1) INTO salida;
        RAISE NOTICE 'Eliminado documento de prueba: %', salida;
                  
    END;
    $$;







-- Declaración de funciones utilizadas

-- general_accc.__alta_documento (in_id, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_descriptor, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.__modifica_documento (in_id, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.__baja_documento (in_documento)

-- general_accc.modifica_id_documento (in_id_nuevo, in_id_viejo)

-- general_accc.alta_depositolegal_documento (in_documento, in_deposito_legal, in_edicion, in_anio, in_generador)

-- general_accc.modifica_depositolegal_documento (in_id, in_documento, in_deposito_legal, in_edicion, in_anio, in_generador)

-- general_accc.baja_depositolegal_documento (in_id, in_documento) 

-- general_accc.alta_descriptor_documento (in_descriptor, in_documento)

-- general_accc.modifica_descriptor_documento (in_id, in_descriptor, in_documento) 

-- general_accc.baja_descriptor_documento (in_id, in_descriptor, in_documento) 

