--------------------------------------------------------------------------------
--                   Pruebas a los SP en 04_SP_Evento.sql                     --
--------------------------------------------------------------------------------


-- Pruebas en la tabla evento

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba alta_evento incorrecto, de tipo Concurso';        
        SELECT general_accc.alta_evento ('Concurso', 2010, 'COAC', 'Localidad 1', 'Provincia 1', 'Ubicación 1', null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_evento correcto';        
        SELECT general_accc.alta_evento ('Efemérides', 2010, 'Cabalgata del Humor 1', 'Localidad 1', 'Provincia 1', 'Ubicación 1', null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';   
        RAISE NOTICE 'Prueba alta_evento incorrecto, nombre duplicado con distinta capitalización';        
        SELECT general_accc.alta_evento ('Efemérides', 2010, 'CABALGATA DEL HUMOR 1', 'Localidad 1', 'Provincia 1', 'Ubicación 1', null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_evento correcto';
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE nombre = 'Cabalgata del Humor 1';
        SELECT general_accc.modifica_evento (auxInt1, null, null, 'CABALGATA 1', 'Localidad 2', 'Provincia 3', 'Ubicación 4', 'modificado') INTO salida;
        RAISE NOTICE '    %', salida;
        SELECT evento INTO auxChar1 FROM general_accc.evento WHERE id = auxInt1;
        RAISE NOTICE '    Valor actual del registro con id %: "%"', auxInt1, auxChar1;
    END;
    $$;


-- Prueba en la tabla documento y documento_evento

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba doc_nuevo_a_evento correcto, una vez';
        
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE nombre = 'CABALGATA 1';
        SELECT id INTO auxInt2 FROM general_accc.descriptor LIMIT 1;
        
        SELECT general_accc.doc_nuevo_a_evento (auxInt1, 10, null, 'Documento de Evento 1', 'Siglo XIX', 'Texto', 'No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt2, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO auxChar1 FROM general_accc.documento WHERE id = 10;
        RAISE NOTICE 'Valor actual del registro con id %: "%"', auxInt1, auxChar1;
        
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba doc_nuevo_a_evento correcto, tangible';
        SELECT general_accc.doc_nuevo_a_evento (auxInt1, 20, null, 'Documento de Evento 1 no tangible', 'Siglo XX modificado', 'Video', 'Electrónico', null, null, null, '/DatosACCC/Ev1.avi', 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt2, null, true, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO auxChar1 FROM general_accc.documento WHERE id = 20;
        RAISE NOTICE 'Valor actual del registro con id %: "%"', auxInt1, auxChar1;
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';    
        RAISE NOTICE 'Prueba doc_existente_a_evento correcta';
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE nombre = 'CABALGATA 1';
        SELECT id INTO auxInt2 FROM general_accc.documento ORDER BY id DESC LIMIT 1;
        SELECT general_accc.doc_existente_a_evento (auxInt2, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_evento incorrecta, por documentos dependientes';
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE nombre = 'CABALGATA 1';
        SELECT general_accc.baja_evento (auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_documento_evento completa e incorrecta para el evento "CABALGATA 1"';
        
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE nombre = 'CABALGATA 1';
        FOR auxRecord IN (SELECT documento 
                              FROM general_accc.documento_evento
                              WHERE evento = auxInt1
                              ORDER BY documento)
        LOOP
            
            SELECT general_accc.baja_documento_evento (auxRecord.documento, auxInt1) INTO salida;
            RAISE NOTICE '    Baja vinculación documento id %: %', auxRecord.documento, salida;
        END LOOP;
         
        RAISE NOTICE 'Prueba baja_evento incorrecta, por documentos dependientes';
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE nombre = 'CABALGATA 1';
        SELECT general_accc.baja_evento (auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
                  
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_documento_evento, retirada del tangible';
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE nombre = 'CABALGATA 1';
        SELECT general_accc.modifica_documento_evento (auxInt1, 20, null, 'Documento de Evento 1 no tangible', 'Siglo XX modificado', 'Video', 'No disponible', null, null, null, '', 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO auxChar1 FROM general_accc.documento WHERE id = 10;
        RAISE NOTICE 'Valor actual del registro con id %: "%"', auxInt1, auxChar1;
        
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_documento_evento completa para el evento "CABALGATA 1"';
        
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE nombre = 'CABALGATA 1';
        FOR auxRecord IN (SELECT documento 
                              FROM general_accc.documento_evento
                              WHERE evento = auxInt1)
        LOOP
            
            SELECT general_accc.baja_documento_evento (auxRecord.documento, auxInt1) INTO salida;
            RAISE NOTICE '    Baja vinculación documento id %: %', auxRecord.documento, salida;
        END LOOP;
                 
        SELECT general_accc.baja_evento (auxInt1) INTO salida;
        RAISE NOTICE '    Baja evento: %', salida;
                  
    END;
    $$;



-- Pruebas en la tabla concurso

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba alta_concurso correcto';        
        SELECT general_accc.alta_concurso (2010, 'COAC', 'Localidad 1', 'Provincia 1', 'Ubicación 1', null, 'Adultos') INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba alta_concurso correcto, otra vez';        
        SELECT general_accc.alta_concurso (2011, 'COAC', 'Localidad 1', 'Provincia 1', 'Ubicación 1', null, 'Adultos') INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_concurso correcto';
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE anio = 2011 AND nombre = 'COAC' AND localidad = 'Localidad 1';
        SELECT general_accc.modifica_concurso (auxInt1, null, null, 'Localidad 2', 'Provincia 3', 'Ubicación 4', null, 'Junior') INTO salida;
        RAISE NOTICE '    %', salida;
        SELECT evento, categoria INTO auxChar1, auxChar2
            FROM general_accc.evento
            INNER JOIN general_accc.concurso
                ON evento.id = concurso.evento
            WHERE id = auxInt1;
        RAISE NOTICE '    Valor actual del registro con id %: "%, %"', auxInt1, auxChar1, auxChar2;
    END;
    $$;






-- Pruebas en la tabla premio

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba alta_premio correcto, primero';     
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE anio = 2011 AND nombre = 'COAC' AND localidad = 'Localidad 2';
        SELECT id INTO auxInt2 FROM general_accc.modalidad WHERE modalidad = 'Comparsa'; 
        SELECT general_accc.alta_premio_concurso (auxInt1, auxInt2, 1, 100.00, 'Por integrante') INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba alta_premio correcto, segundo';     
        SELECT general_accc.alta_premio_concurso (auxInt1, auxInt2, 2, 50.00, 'Por integrante') INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba alta_premio correcto, tercero';     
        SELECT general_accc.alta_premio_concurso (auxInt1, auxInt2, 3, 10.00, 'Por integrante') INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba alta_premio correcto, primero';     
        SELECT id INTO auxInt2 FROM general_accc.modalidad WHERE modalidad = 'Chirigota'; 
        SELECT general_accc.alta_premio_concurso (auxInt1, auxInt2, 1, 100.00, 'Por integrante') INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba alta_premio correcto, segundo';
        SELECT general_accc.alta_premio_concurso (auxInt1, auxInt2, 2, 50.00, 'Por integrante') INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba alta_premio correcto, tercero';      
        SELECT general_accc.alta_premio_concurso (auxInt1, auxInt2, 3, 10.00, 'Por integrante') INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxChar3 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_premio correcto';
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE anio = 2011 AND nombre = 'COAC' AND localidad = 'Localidad 2';
        SELECT id INTO auxInt2 FROM general_accc.modalidad WHERE modalidad = 'Comparsa'; 
        SELECT id INTO auxInt3 FROM general_accc.premio WHERE concurso = auxInt1 AND modalidad = auxInt2 AND premio = 1;
        SELECT general_accc.modifica_premio_concurso (auxInt3, auxInt1, auxInt2, null, 150.00, null) INTO salida;
        RAISE NOTICE '    %', salida;
        SELECT evento.nombre || ', ' || evento.anio || ', ' || evento.localidad, categoria, premio
                INTO auxChar1, auxChar2, auxChar3
            FROM general_accc.evento
            INNER JOIN general_accc.concurso
                ON evento.id = concurso.evento
            INNER JOIN general_accc.premio
                ON concurso.evento = premio.concurso
            WHERE modalidad = auxInt2
                AND premio = 1;
        RAISE NOTICE '    Valor actual del registro con id %: "%, %, %"', auxInt2, auxChar1, auxChar2, auxChar3;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_premio_concurso completa para el concurso "2011, COAC"';
        
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE anio = 2011 AND nombre = 'COAC' AND localidad = 'Localidad 2';
        
        FOR auxRecord IN (SELECT id 
                              FROM general_accc.premio
                              WHERE concurso = auxInt1)
        LOOP            
            SELECT general_accc.baja_premio_concurso (auxInt1, auxRecord.id) INTO salida;
            RAISE NOTICE '    Baja premio id %: %', auxRecord.id, salida;
        END LOOP;
                 
        SELECT general_accc.baja_concurso (auxInt1) INTO salida;
        RAISE NOTICE '    Baja concurso id %: %', auxInt1, salida;
                 
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE anio = 2010 AND nombre = 'COAC' AND localidad = 'Localidad 1';
        SELECT general_accc.baja_concurso (auxInt1) INTO salida;
        RAISE NOTICE '    Baja concurso id %: %', auxInt1, salida;
    
    END;
    $$;






-- Declaración de funciones utilizadas

-- general_accc.alta_evento (in_tipo_evento, in_anio, in_nombre, in_localidad, in_provincia, in_ubicacion, in_descripcion)

-- general_accc.modifica_evento (in_id, in_tipo_evento, in_anio, in_nombre, in_localidad, in_provincia, in_ubicacion, in_descripcion)

-- general_accc.baja_evento (in_id)

-- general_accc.alta_concurso (in_anio, in_nombre, in_localidad, in_provincia, in_ubicacion, in_descripcion, in_categoria character varying)

-- general_accc.modifica_concurso (in_evento, in_anio, in_nombre, in_localidad, in_provincia, in_ubicacion, in_descripcion, in_categoria character varying)

-- general_accc.baja_concurso (in_evento)

-- general_accc.alta_premio_concurso (in_concurso, in_modalidad, in_premio, in_cuantia numeric(10,0), in_observaciones)

-- general_accc.modifica_premio_concurso (in_id, in_concurso, in_modalidad, in_premio, in_cuantia numeric(10,0), in_observaciones)

-- general_accc.baja_premio_concurso (in_concurso, in_id)

-- general_accc.doc_nuevo_a_evento (in_evento, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_descriptor, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.modifica_documento_evento (in_evento, in_documento, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.doc_existente_a_evento (in_documento, in_evento)

-- general_accc.baja_documento_evento (in_documento, in_evento)


