--------------------------------------------------------------------------------
--               Pruebas a los SP en 061_SP_ObraLiteraria.sql                 --
--------------------------------------------------------------------------------



-- Pruebas en la tabla literaria, obra y documento_obra

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_literaria incorrecta, por el Código de referencia: ES.AC//1, (el prefijo)'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.alta_literaria (1, 'Presentación, 10 pasodobles, 8 cuplés y popurrí', 100, 'ES.AC//1', 'Errónea', '2011', 'Texto', 'No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_literaria incorrecta, por el Código de referencia: ES.ACCC//2, (la signatura)'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.alta_literaria (1, 'Presentación, 10 pasodobles, 8 cuplés y popurrí', 100, 'ES.ACCC//2', 'Errónea', '2011', 'Texto', 'No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_literaria incorrecta, por el Nivel de Descripción'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.alta_literaria (1, 'Presentación, 10 pasodobles, 8 cuplés y popurrí', 100, null, 'Errónea', '2011', 'Texto', 'No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_literaria incorrecta, por el tipo'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.alta_literaria (1, 'Presentación, 10 pasodobles, 8 cuplés y popurrí', 100, null, 'Errónea', '2011', 'Imagen', 'No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_literaria correcta, aun sin indicar el identificador del documento ES.ACCC//1'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.alta_literaria (1, 'Presentación, 10 pasodobles, 8 cuplés y popurrí', 100, 'ES.ACCC//1', 'En las mismas de siempre', '2011', 'Texto', 'No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba doc_nuevo_a_literaria correcta'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.doc_nuevo_a_literaria (1, 200, null, 'Expediente de Censura', '2011', 'Texto', 'Papel', null, null, null, '/Datos/1-300-ExpCensura.pdf', 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, true, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO salida FROM general_accc.documento WHERE id = 200;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba doc_nuevo_a_literaria incorrecta, sin indicar el identificador del documento solo puede haber uno'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.doc_nuevo_a_literaria (1, 300, 'ES.ACCC//1', 'Expediente de Censura', '2011', 'Texto', 'No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
    
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba de vinculación a agrupación correcta';
  
        SELECT id INTO auxInt1 FROM general_accc.modalidad WHERE modalidad = 'Comparsa';
        SELECT general_accc.alta_agrupacionanio (null, null, 'Localidad Agrupacion', 'Provincia Agrupacion', 'En las mismas de siempre', 2011, 'Adultos', auxInt1, null, 'Masculina', 15, null, null, null, null, true, 'Prensa', null, null, null, null) INTO salida;       

        SELECT entidad,id INTO auxInt1, auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
        
        SELECT general_accc.modifica_agrupacionanio (auxInt1, auxInt2,null,null,null,null,null,null,null,null,null,null,null,null,null,null,1,null,null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_literaria correcta, cambio de título al que no lo contiene';
  
        SELECT general_accc.modifica_literaria (1, null, 200, null, 'Otro título', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO salida FROM general_accc.documento WHERE id = 200;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_literaria incorrecta, cambio de título al único que lo contiene';
  
        SELECT general_accc.modifica_literaria (1, null, 100, null, 'Erróneo', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_literaria incorrecta, por el tipo de documento';
  
        SELECT general_accc.modifica_literaria (1, null, 100, null, null, null, 'Imagen', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_literaria incorrecta, por el nivel de descripción';
  
        SELECT general_accc.modifica_literaria (1, null, 100, null, null, null, null, null, null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;



-- Bloques de eliminación de registros de prueba

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        SELECT entidad, id INTO auxInt1, auxInt2 FROM general_accc.agrupacion_anio
            WHERE nombre = 'En las mismas de siempre';
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_literaria_agrupacionanio correcta';  
        SELECT general_accc.baja_literaria_agrupacionanio (auxInt1, auxInt2) INTO salida;
        RAISE NOTICE '    Baja obra literaria: %', salida;
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_agrupacionanio correcta, borrará agrupación de nivel superior'; 
        SELECT general_accc.baja_agrupacionanio (auxInt1, auxInt2) INTO salida;
        RAISE NOTICE '    Baja AgrupacionAnio: %', salida;
        
        SELECT agrupacion INTO salida FROM general_accc.agrupacion
            WHERE localidad = 'Localidad Agrupacion'
                AND provincia = 'Provincia Agrupacion';
        RAISE NOTICE '    Valor de la agrupación que se le creó: %', salida;
        
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_documento_literaria correcta'; 
        SELECT general_accc.__modifica_documento (200, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        SELECT general_accc.baja_documento_literaria (200, 1) INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE 'Prueba baja_literaria correcta';
        SELECT general_accc.baja_literaria (1, 100) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

 


-- Declaración de funciones utilizadas

-- general_accc.alta_literaria (in_signatura_obra, in_repertorio, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_descriptor, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.modifica_literaria (in_signatura_obra, in_repertorio, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.baja_literaria (in_signatura_obra, in_documento)

-- general_accc.modifica_signatura_literaria (in_signatura_nueva, in_signatura_vieja)

-- general_accc.doc_nuevo_a_literaria (in_signatura_obra, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_descriptor, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.doc_existente_a_literaria (in_obra_literaria, in_documento)

-- general_accc.baja_documento_literaria (in_documento, in_obra_literaria)
