--------------------------------------------------------------------------------
--                Pruebas a los SP en 061_SP_ObraGrafica.sql                  --
--------------------------------------------------------------------------------



-- Pruebas en la tabla grafica, obra y documento_obra
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_grafica incorrecta, tipo audio no admitido'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.alta_grafica (3, 700, 'ES.ACCC//3', 'En las mismas de siempre', '2011', 'Audio', 'No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_grafica correcta, sin indicar el identificador del documento ES.ACCC//2'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.alta_grafica (3, 700, 'ES.ACCC//3', 'En las mismas de siempre', '2011', 'Expediente', 'No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba doc_nuevo_a_grafica correcta'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.doc_nuevo_a_grafica (3, 800, null, 'Ensayos', '2011', 'Expediente', 'Papel', null, null, null, '/Datos/3-800/', 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, true, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO salida FROM general_accc.documento WHERE id = 800;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba de vinculación a agrupación correcta';
  
        SELECT id INTO auxInt1 FROM general_accc.modalidad WHERE modalidad = 'Comparsa';
        SELECT general_accc.alta_agrupacionanio (null, null, 'Localidad Agrupacion', 'Provincia Agrupacion', 'En las mismas de siempre', 2011, 'Adultos', auxInt1, null, 'Masculina', 15, null, null, null, null, true, 'Prensa', null, null, null, null) INTO salida;       

        SELECT entidad,id INTO auxInt1, auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
        
        SELECT general_accc.modifica_agrupacionanio (auxInt1, auxInt2,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,3) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba doc_nuevo_a_grafica correcta, tras vincular la agrupación de nivel documental simple'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.doc_nuevo_a_grafica (3, 900, null, 'Actuación en la Peña la Estrella', '2011', 'Video', 'VHS', null, null, null, '/Datos/2-6000-PeñaLaEstrella-Presentacion.avi', 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, true, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO salida FROM general_accc.documento WHERE id = 900;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_grafica incorrecta, cambio de título al único que lo contiene';
  
        SELECT general_accc.modifica_grafica (3, 700, null, 'Erróneo', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_grafica correcta, cambio de título al que no lo contiene';
  
        SELECT general_accc.modifica_grafica (3, 800, null, 'Actuación en COAC', '2011', 'Video', 'DVD', null, null, null, '/Datos/3-800-COAC.mkv', 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, true, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO salida FROM general_accc.documento WHERE id = 800;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba doc_existente_a_literaria, de tipo vídeo';    
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.alta_literaria (12, 'Presentación, 10 pasodobles, 8 cuplés y popurrí', 102, 'ES.ACCC//12', 'En las mismas de siempre', '2011', 'Texto', 'No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        SELECT general_accc.doc_existente_a_literaria (12, 800) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;



-- Bloques de eliminación de registros de prueba

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_documento_grafica del documento asociado a la literaria, el cual sigue existiendo';    
        SELECT general_accc.baja_documento_grafica (800, 3) INTO salida;
        RAISE NOTICE '    Baja en grafica: %', salida;
        SELECT documento INTO salida FROM general_accc.documento WHERE id = 800;
        RAISE NOTICE '%', salida;
        SELECT COUNT(documento_obra) INTO salida
            FROM general_accc.documento_obra
            WHERE documento = 800;
        RAISE NOTICE '    Consulta en documento_obra del total de ocurrencias: %', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        SELECT entidad, id INTO auxInt1, auxInt2 FROM general_accc.agrupacion_anio
            WHERE nombre = 'En las mismas de siempre';
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_grafica_agrupacionanio correcta';  
        SELECT general_accc.baja_tipo_agrupacionanio (auxInt1, auxInt2) INTO salida;
        RAISE NOTICE '    Baja obra grafica: %', salida;
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_agrupacionanio correcta, borrará agrupación de nivel superior';        
        SELECT general_accc.baja_agrupacionanio (auxInt1, auxInt2) INTO salida;
        RAISE NOTICE '    Baja AgrupacionAnio: %', salida;
                    
        SELECT agrupacion INTO salida FROM general_accc.agrupacion
            WHERE localidad = 'Localidad Agrupacion'
                AND provincia = 'Provincia Agrupacion';
        RAISE NOTICE '    Valor de la agrupación que se le creó: %', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_documento_grafica correcta'; 
        SELECT general_accc.__modifica_documento (900, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        SELECT general_accc.baja_documento_grafica (900, 3) INTO salida;
        RAISE NOTICE '    %', salida;
        SELECT COUNT(documento) INTO salida
            FROM general_accc.documento
            WHERE id = 900;
        RAISE NOTICE '    Consulta en documento_obra del total de ocurrencias: %', salida;

        
        END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN

    
        SELECT general_accc.__modifica_documento (700, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        RAISE NOTICE 'Prueba baja_grafica correcta';
        SELECT general_accc.baja_grafica (3, 700) INTO salida;
        RAISE NOTICE '    %', salida;


        END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN

    
        
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Baja a la literaria de pruebas'; 
        SELECT general_accc.__modifica_documento (800, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        SELECT general_accc.baja_documento_literaria (800, 12) INTO salida;
        RAISE NOTICE '     %', salida;

END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        
        RAISE NOTICE '     Se utiliza baja_literaria respecto a esto último';
        SELECT general_accc.baja_literaria (12, 102) INTO salida;
        RAISE NOTICE '     %', salida;
    END;
    $$;

 
 

-- Declaración de funciones utilizadas

-- general_accc.alta_grafica (in_signatura_obra, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_descriptor, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.modifica_grafica (in_signatura_obra, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.baja_grafica (in_signatura_obra, in_documento)

-- general_accc.modifica_signatura_grafica (in_signatura_nueva, in_signatura_vieja)

-- general_accc.doc_nuevo_a_grafica (in_signatura_obra, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_descriptor, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.doc_existente_a_grafica (in_documento, in_obra_grafica)

-- general_accc.baja_documento_grafica (in_documento, in_obra_grafica)
