--------------------------------------------------------------------------------
--                   Pruebas al los SP en 073_SP_Disenio.sql                  --
--------------------------------------------------------------------------------


-- Pruebas en la tabla disenio y documento_disenio

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Creación de obra grafica para pruebas'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.alta_grafica (33, 114,null, 'La eternidad', '2017', 'Texto', 'No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_disenio correcta, debe asignarse la signatura dentro de la obra automáticamente'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1; 
        SELECT id INTO auxInt3 FROM general_accc.tema LIMIT 1;       
        SELECT general_accc.alta_disenio (33,null,auxInt2,'Disfraz',auxInt3, null, null,'Disfraz de Manue','2017','Imagen','No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_disenio correcta, se indica la signatura y no el documento'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1;  
        SELECT id INTO auxInt3 FROM general_accc.tema LIMIT 1;
        SELECT general_accc.alta_disenio (33,40,auxInt2,'Forillo',auxInt3, 1040, null,'Actuación en COAC','2017','Video','DVD', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_disenio incorrecta, por el nivel de descripcion'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1; 
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1;  
        SELECT id INTO auxInt3 FROM general_accc.tema LIMIT 1;      
        SELECT general_accc.alta_disenio (33,null,auxInt2,'Caracterización',auxInt3, null, null,'Factura maquillaje','2017','Texto','No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_disenio incorrecta, por el tipo de documento'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1; 
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1;  
        SELECT id INTO auxInt3 FROM general_accc.tema LIMIT 1;      
        SELECT general_accc.alta_disenio (33,null,auxInt2,'Caracterización',auxInt3, null, null,'Factura maquillaje','2017','Audio','No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_disenio incorrecta, por ser el segundo componente de tipo Forillo'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1; 
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1;  
        SELECT id INTO auxInt3 FROM general_accc.tema LIMIT 1;      
        SELECT general_accc.alta_disenio (33,null,auxInt2,'Forillo',auxInt3, null, null,'Descripción y motivos','2017','Texto','No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;


DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba doc_nuevo_a_disenio correcta'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;  
        SELECT id INTO auxInt2 FROM general_accc.disenio where obra_grafica = 33 AND signatura = 40;       
        SELECT general_accc.doc_nuevo_a_disenio (auxInt2, 33, 40, 1041, null, 'Actuación COAC', '2011', 'Video', 'Electrónico', null, null, null, '/Datos/1-1004-ActuacionCOAC-P2.pdf', 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, true, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO salida FROM general_accc.documento WHERE id = 1041;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_disenio correcta'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1; 
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1;  
        SELECT id INTO auxInt3 FROM general_accc.tema LIMIT 1;      
        SELECT general_accc.alta_disenio (33,null,auxInt2,'Caracterización',auxInt3, 1042, null,'Factura maquillaje','2017','Texto','No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxRecord record;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_disenio correcta, se indica el documento'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1;  
        SELECT id INTO auxInt3 FROM general_accc.tema LIMIT 1;      
        SELECT general_accc.alta_disenio (33,null,auxInt2,'Atrezo',auxInt3, 1043, null,'Factura maquillaje','2017','Texto','No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;

        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Signaturas asignadas automáticamente'; 
        
        FOR auxRecord IN (SELECT doc.id, signatura, "3_1_1_codigo_referencia"
                              FROM general_accc.documento_disenio AS d_l
                              INNER JOIN general_accc.documento AS doc
                                  ON d_l.documento = doc.id
                              INNER JOIN general_accc.disenio
                                  ON d_l.disenio = disenio.id
                              WHERE disenio.obra_grafica = 33)
        LOOP
            RAISE NOTICE '    Documento, Signatura, Código de Referencia: %', auxRecord;
        END LOOP;
        
    END;
    $$;



-- Pruebas en tabla tema_disenio

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_tema_disenio correcta';
        SELECT id INTO auxInt1 FROM general_accc.disenio
            WHERE obra_grafica = 33
            ORDER BY id;  
        SELECT id INTO auxInt2
            FROM general_accc.disenio
            WHERE id NOT IN (SELECT tema
                                 FROM general_accc.tema_disenio
                                 WHERE disenio = auxInt1)
            LIMIT 1;
        SELECT general_accc.alta_tema_disenio (auxInt2, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_tema_disenio correcta';
        SELECT id INTO auxInt1 FROM general_accc.disenio
            WHERE obra_grafica = 33
            ORDER BY id;  
        SELECT id INTO auxInt2
            FROM general_accc.disenio
            WHERE id NOT IN (SELECT tema
                                 FROM general_accc.tema_disenio
                                 WHERE disenio = auxInt1)
            LIMIT 1;
        SELECT general_accc.alta_tema_disenio (auxInt2, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba modifica_tema_disenio correcta';
        SELECT id INTO auxInt2
            FROM general_accc.tema_disenio
            WHERE disenio = auxInt1;
                             
        SELECT id INTO auxInt3
            FROM general_accc.tema
            WHERE id NOT IN (SELECT tema
                             FROM general_accc.tema_disenio
                             WHERE disenio = auxInt1)
            ORDER BY id ASC
            LIMIT 1;
            
        SELECT general_accc.modifica_tema_disenio (auxInt2, auxInt3, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_tema_disenio incorrecta, duplicado';
        
        SELECT id INTO auxInt1 FROM general_accc.disenio
            WHERE obra_grafica = 33
            ORDER BY id;  
        
        SELECT tema INTO auxInt2 FROM general_accc.tema_disenio WHERE disenio = auxInt1 LIMIT 1;
            
        SELECT general_accc.alta_tema_disenio (auxInt2, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;

    END;
    $$;

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxInt4 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_tema_disenio incorrecta, cambiar la disenio';
                
        SELECT id INTO auxInt1 FROM general_accc.disenio
            WHERE obra_grafica = 33
            ORDER BY id;  
        SELECT id, tema, disenio INTO auxInt2, auxInt3, auxInt4
            FROM general_accc.tema_disenio
            WHERE disenio = auxInt1 LIMIT 1;

        SELECT id INTO auxInt1
            FROM general_accc.disenio
            WHERE id <> auxInt4 LIMIT 1;
            
        SELECT general_accc.modifica_tema_disenio (auxInt2, auxInt3, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;

    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_tema_disenio completa, falla en el último';
           
        SELECT id INTO auxInt1 FROM general_accc.disenio
            WHERE obra_grafica = 33
            ORDER BY id;  
        FOR auxRecord IN (SELECT id, tema, disenio 
                              FROM general_accc.tema_disenio
                              WHERE disenio = auxInt1)
        LOOP
            
            SELECT general_accc.baja_tema_disenio (auxRecord.id, auxRecord.tema, auxRecord.disenio) INTO salida;
            RAISE NOTICE '%', salida;
        END LOOP;

    END;
    $$;



-- Pruebas en tabla crea

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_crea_disenio correcta';
        SELECT id INTO auxInt1 FROM general_accc.disenio
            WHERE obra_grafica = 33
            ORDER BY id;  
        SELECT entidad INTO auxInt2
            FROM general_accc.empresa
            LIMIT 1;
        SELECT general_accc.alta_crea_disenio (auxInt1, auxInt2, 200.0, '10 meses') INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_crea_disenio correcta';
        SELECT id INTO auxInt1 FROM general_accc.disenio
            WHERE obra_grafica = 33
            ORDER BY id;  
        SELECT entidad INTO auxInt2
            FROM general_accc.empresa
            WHERE entidad NOT IN (SELECT entidad
                                     FROM general_accc.crea
                                     WHERE disenio = auxInt1)
            LIMIT 1;
        SELECT general_accc.alta_crea_disenio (auxInt1, auxInt2, 0.0, 'No se utilizó') INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba modifica_crea_disenio correcta, cambia la entidad';
        SELECT id INTO auxInt2
            FROM general_accc.crea
            WHERE disenio = auxInt1;
                             
        SELECT entidad INTO auxInt3
            FROM general_accc.empresa
            WHERE entidad NOT IN (SELECT entidad
                                     FROM general_accc.crea
                                     WHERE disenio = auxInt1)
            ORDER BY entidad ASC
            LIMIT 1;
            
        SELECT general_accc.modifica_crea_disenio (auxInt2, auxInt1, auxInt3, null, 'cambiado el creador') INTO salida;
        RAISE NOTICE '%', salida;
        
        
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Estado de las creaciones para la obra de pruebas';

        FOR auxChar1 IN (SELECT "Empresa_Creaciones"
                            FROM general_accc."Empresa_Creaciones"
                            WHERE obra = 33)
        LOOP
            RAISE NOTICE '    %', auxChar1;
        END LOOP;

    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_crea_disenio incorrecta, duplicado';
        
        SELECT id INTO auxInt1 FROM general_accc.disenio
            WHERE obra_grafica = 33
            ORDER BY id;  
        
        SELECT entidad INTO auxInt2 FROM general_accc.crea WHERE disenio = auxInt1 LIMIT 1;
            
        SELECT general_accc.alta_crea_disenio (auxInt1, auxInt2, null, 'Erróneo') INTO salida;
        RAISE NOTICE '%', salida;

    END;
    $$;






-- Bloques de eliminación de registros de prueba

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_crea_disenio completa, para los diseños de la obra de pruebas';
           
        SELECT id INTO auxInt1 FROM general_accc.disenio
            WHERE obra_grafica = 33
            ORDER BY id;  
        FOR auxRecord IN (SELECT id, entidad, disenio 
                              FROM general_accc.crea
                              WHERE disenio = auxInt1)
        LOOP
            
            SELECT general_accc.baja_crea_disenio (auxRecord.id, auxRecord.disenio, auxRecord.entidad) INTO salida;
            RAISE NOTICE '%', salida;
        END LOOP;

    END;
    $$;


DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
       
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_documento_disenio incorrecta, el documento no tiene más vínculos dentro de la BBDD y es tangible';  
        SELECT id INTO auxInt1 FROM general_accc.disenio where obra_grafica = 33 AND signatura = 40; 
        SELECT general_accc.baja_documento_disenio (1041, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
       
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_documento_disenio correcta, es el penúltimo asociado';
        
        SELECT id INTO auxInt1 FROM general_accc.disenio where obra_grafica = 33 AND signatura = 40;  

        SELECT general_accc.baja_documento_disenio (1040, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        
    END;
    $$;
    
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Baja al resto de disenios creadas';
        
        SELECT disenio.id, disenio.signatura INTO auxInt1, auxInt2
            FROM general_accc.disenio
            INNER JOIN general_accc.documento_disenio AS d_l
                ON disenio.id = d_l.disenio
            WHERE obra_grafica = 33
                AND documento = 1041;  
        SELECT general_accc.__modifica_documento (1041, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        SELECT general_accc.baja_disenio (auxInt1, 33, auxInt2, 1041) INTO salida;
        RAISE NOTICE '    Documento 1041: %', salida;
        
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN 
        SELECT disenio.id, disenio.signatura INTO auxInt1, auxInt2
            FROM general_accc.disenio
            INNER JOIN general_accc.documento_disenio AS d_l
                ON disenio.id = d_l.disenio
            WHERE obra_grafica = 33
                AND documento = 1042;    
        SELECT general_accc.__modifica_documento (1042, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        SELECT general_accc.baja_disenio (auxInt1, 33, auxInt2, 1042) INTO salida;
        RAISE NOTICE '    Documento 1042: %', salida;
        
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN  
        SELECT disenio.id, disenio.signatura INTO auxInt1, auxInt2
            FROM general_accc.disenio
            INNER JOIN general_accc.documento_disenio AS d_l
                ON disenio.id = d_l.disenio
            WHERE obra_grafica = 33
                AND documento = 1043;   
        SELECT general_accc.__modifica_documento (1043, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        SELECT general_accc.baja_disenio (auxInt1, 33, auxInt2, 1043) INTO salida;
        RAISE NOTICE '    Documento 1043: %', salida;
        
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_disenio respecto a la primera, donde no se indicado el documento ni la signatura';
        SELECT disenio.id, disenio.signatura, d_l.documento  INTO auxInt1, auxInt2, auxInt3
            FROM general_accc.disenio
            INNER JOIN general_accc.documento_disenio AS d_l
                ON disenio.id = d_l.disenio
            WHERE obra_grafica = 33;  
        SELECT general_accc.baja_disenio (auxInt1, 33, auxInt2, auxInt3) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_grafica correcta';
        SELECT general_accc.baja_grafica (33, 114) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

  


-- Declaración de funciones utilizadas

-- general_accc.alta_disenio (in_signatura_grafica, in_signatura_disenio, in_autoria_disenio, in_tipo_disenio, in_tema, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_descriptor, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.modifica_disenio (in_id_disenio, in_signatura_grafica, in_signatura_disenio, in_autoria_disenio, in_tipo_disenio, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.baja_disenio (in_id_disenio, in_signatura_grafica, in_signatura_disenio, in_id_doc)

-- general_accc.__alta_documento_disenio (in_documento, in_disenio)

-- general_accc.doc_existente_a_disenio (in_documento, in_disenio)

-- general_accc.baja_documento_disenio (in_documento, in_disenio)

-- general_accc.doc_nuevo_a_disenio (in_id_disenio, in_signatura_grafica, in_signatura_disenio, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_descriptor, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.alta_tema_disenio (in_tema, in_disenio)

-- general_accc.modifica_tema_disenio (in_id, in_tema, in_disenio)

-- general_accc.baja_tema_disenio (in_id, in_tema, in_disenio)

-- general_accc.alta_crea_disenio (in_disenio, in_entidad, in_coste numeric (10,0), in_observaciones)

-- general_accc.modifica_crea_disenio (in_id, in_disenio, in_entidad, in_coste numeric (10,0), in_observaciones)

-- general_accc.baja_crea_disenio (in_id, in_disenio, in_entidad)
