-- TFG BBDD Carnaval de Cádiz - Paloma Cortés



-- Creación de usuarios

CREATE ROLE admin_accc_ROLE;
CREATE ROLE general_accc_ROLE;

CREATE USER admin_accc password 'accc';
CREATE USER general_accc password 'accc';

GRANT admin_accc_ROLE TO admin_accc;
GRANT general_accc_ROLE TO general_accc;



-- Gestión de permisos

REVOKE CONNECT ON DATABASE carnaval FROM PUBLIC;
GRANT CONNECT ON DATABASE carnaval TO general_accc_ROLE;


GRANT ALL ON DATABASE carnaval TO admin_accc_ROLE;

GRANT USAGE ON LANGUAGE plpgsql TO general_accc_ROLE;
