--------------------------------------------------------------------------------
--               Pruebas al los SP en 01_SP_tablasLookup.sql                  --
--------------------------------------------------------------------------------



-- Pruebas en la tabla modalidad

DO

    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE ' '; 
    
        RAISE NOTICE 'Prueba alta_modalidad "Modalidad 1"';        
        SELECT general_accc.alta_modalidad('Modalidad 1') INTO salida;
        RAISE NOTICE '%', salida;

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_modalidad';
        SELECT id INTO auxInt1 FROM general_accc.modalidad WHERE modalidad = 'Modalidad 1';
        RAISE NOTICE '    El identificador del modalidad insertado es: %', auxInt1;
        SELECT general_accc.modifica_modalidad(auxInt1,'Modalidad 1 modificado') INTO salida;
        RAISE NOTICE '%', salida;
        SELECT modalidad INTO auxChar1 FROM general_accc.modalidad WHERE id = auxInt1;
        RAISE NOTICE 'Valor actual del registro con id %: "%"', auxInt1, auxChar1;
        

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_modalidad';
        SELECT general_accc.baja_modalidad(auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba duplicar valor de modalidad con alta_modalidad';  
        SELECT id, modalidad INTO auxInt1, auxChar1 FROM general_accc.modalidad LIMIT 1;
        RAISE NOTICE '    Se intenta dar alta al modalidad existente: %', auxChar1;  
        SELECT general_accc.alta_modalidad(auxChar1) INTO salida;
        RAISE NOTICE '%', salida;
        
    END;
    $$;





-- Pruebas en la tabla descriptor

DO

    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE ' '; 
    
        RAISE NOTICE 'Prueba alta_descriptor "Descriptor 1"';        
        SELECT general_accc.alta_descriptor('Descriptor 1') INTO salida;
        RAISE NOTICE '%', salida;

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_descriptor';
        SELECT id INTO auxInt1 FROM general_accc.descriptor WHERE descriptor = 'Descriptor 1';
        RAISE NOTICE '    El identificador del descriptor insertado es: %', auxInt1;
        SELECT general_accc.modifica_descriptor(auxInt1,'Descriptor 1 modificado') INTO salida;
        RAISE NOTICE '%', salida;
        SELECT descriptor INTO auxChar1 FROM general_accc.descriptor WHERE id = auxInt1;
        RAISE NOTICE 'Valor actual del registro con id %: "%"', auxInt1, auxChar1;
        

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_descriptor';
        SELECT general_accc.baja_descriptor(auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba duplicar valor de descriptor con alta_descriptor';  
        SELECT id, descriptor INTO auxInt1, auxChar1 FROM general_accc.descriptor LIMIT 1;
        RAISE NOTICE '    Se intenta dar alta al descriptor existente: %', auxChar1;  
        SELECT general_accc.alta_descriptor(auxChar1) INTO salida;
        RAISE NOTICE '%', salida;
        
    END;
    $$;





-- Pruebas en la tabla tema

DO

    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
    BEGIN

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE ' '; 
    
        RAISE NOTICE 'Prueba alta_tema "Tema 1"';        
        SELECT general_accc.alta_tema('Tema 1','Comentario 1') INTO salida;
        RAISE NOTICE '%', salida;

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_tema';
        SELECT id INTO auxInt1 FROM general_accc.tema WHERE tema = 'Tema 1';
        RAISE NOTICE '    El identificador del tema insertado es: %', auxInt1;
        SELECT general_accc.modifica_tema(auxInt1,'Tema 1 modificado', null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT tema, descripcion INTO auxChar1, auxChar2 FROM general_accc.tema WHERE id = auxInt1;
        RAISE NOTICE 'Valor actual del registro con id %: "%", "%"', auxInt1, auxChar1, auxChar2;
        

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_tema';
        SELECT general_accc.baja_tema(auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba duplicar valor de tema con alta_tema';  
        SELECT id, tema INTO auxInt1, auxChar1 FROM general_accc.tema LIMIT 1;
        RAISE NOTICE '    Se intenta dar alta al tema existente: %', auxChar1;  
        SELECT general_accc.alta_tema(auxChar1, null) INTO salida;
        RAISE NOTICE '%', salida;
        
    END;
    $$;





-- Pruebas en la tabla instrumento

DO

    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE ' '; 
    
        RAISE NOTICE 'Prueba alta_instrumento "Instrumento 1"';        
        SELECT general_accc.alta_instrumento('Instrumento 1') INTO salida;
        RAISE NOTICE '%', salida;

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_instrumento';
        SELECT id INTO auxInt1 FROM general_accc.instrumento WHERE instrumento = 'Instrumento 1';
        RAISE NOTICE '    El identificador del instrumento insertado es: %', auxInt1;
        SELECT general_accc.modifica_instrumento(auxInt1,'Instrumento 1 modificado') INTO salida;
        RAISE NOTICE '%', salida;
        SELECT instrumento INTO auxChar1 FROM general_accc.instrumento WHERE id = auxInt1;
        RAISE NOTICE 'Valor actual del registro con id %: "%"', auxInt1, auxChar1;
        

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_instrumento';
        SELECT general_accc.baja_instrumento(auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba duplicar valor de instrumento con alta_instrumento';  
        SELECT id, instrumento INTO auxInt1, auxChar1 FROM general_accc.instrumento LIMIT 1;
        RAISE NOTICE '    Se intenta dar alta al instrumento existente: %', auxChar1;  
        SELECT general_accc.alta_instrumento(auxChar1) INTO salida;
        RAISE NOTICE '%', salida;
        
    END;
    $$;




-- Pruebas en la tabla actividad

DO

    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE ' '; 
    
        RAISE NOTICE 'Prueba alta_actividad "Actividad 1"';        
        SELECT general_accc.alta_actividad('Actividad 1') INTO salida;
        RAISE NOTICE '%', salida;

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_actividad';
        SELECT id INTO auxInt1 FROM general_accc.actividad WHERE actividad = 'Actividad 1';
        RAISE NOTICE '    El identificador del actividad insertado es: %', auxInt1;
        SELECT general_accc.modifica_actividad(auxInt1,'Actividad 1 modificado') INTO salida;
        RAISE NOTICE '%', salida;
        SELECT actividad INTO auxChar1 FROM general_accc.actividad WHERE id = auxInt1;
        RAISE NOTICE 'Valor actual del registro con id %: "%"', auxInt1, auxChar1;
        

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_actividad';
        SELECT general_accc.baja_actividad(auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        

        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba duplicar valor de actividad con alta_actividad';  
        SELECT id, actividad INTO auxInt1, auxChar1 FROM general_accc.actividad LIMIT 1;
        RAISE NOTICE '    Se intenta dar alta al actividad existente: %', auxChar1;  
        SELECT general_accc.alta_actividad(auxChar1) INTO salida;
        RAISE NOTICE '%', salida;
        
    END;
    $$;


