--------------------------------------------------------------------------------
--               Pruebas a los SP en 05_SP_AgrupacionAnio.sql                 --
--------------------------------------------------------------------------------



-- Pruebas en la tabla agrupacion_anio

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';     
        RAISE NOTICE 'Prueba alta_agrupacionanio incorrecta, a agrupación existente sin fuentes';   
        SELECT entidad INTO auxInt1 FROM general_accc.agrupacion LIMIT 1;
        SELECT id INTO auxInt2 FROM general_accc.modalidad WHERE modalidad = 'Comparsa';
             
        SELECT general_accc.alta_agrupacionanio (auxInt1, null, null, null, 'Cogehlo ahí', 2011, 'Adultos', auxInt2, null, 'Masculina', 15, null, null, null, null, true, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_agrupacionanio correcta, a agrupación existente con fuentes';   
        SELECT entidad INTO auxInt1 FROM general_accc.agrupacion ORDER BY entidad ASC LIMIT 1;
        SELECT id INTO auxInt2 FROM general_accc.modalidad WHERE modalidad = 'Chirigota';
             
        SELECT general_accc.alta_agrupacionanio (auxInt1, null, null, null, 'Cogehlo ahí', 2011, 'Junior', auxInt2, null, 'Masculina', 15, null, null, null, null, true, 'Prensa', null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_agrupacionanio incorrecta, sin agrupación existente ni localidad';   
        SELECT id INTO auxInt1 FROM general_accc.modalidad WHERE modalidad = 'Comparsa';
             
        SELECT general_accc.alta_agrupacionanio (null, null, null, 'Provincia Agrupacion', 'En las mismas de siempre', 2011, 'Adultos', auxInt1, null, 'Masculina', 15, null, null, null, null, true, 'Prensa', null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_agrupacionanio correcta, sin agrupación existente';   
        SELECT id INTO auxInt1 FROM general_accc.modalidad WHERE modalidad = 'Comparsa';
             
        SELECT general_accc.alta_agrupacionanio (null, null, 'Localidad Agrupacion', 'Provincia Agrupacion', 'En las mismas de siempre', 2011, 'Adultos', auxInt1, null, 'Masculina', 15, null, null, null, null, true, 'Prensa', null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_agrupacionanio correcta: "En las mismas de siempre"';    

        SELECT entidad, id INTO auxInt1, auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre'; 
        SELECT id INTO auxInt3 FROM general_accc.modalidad WHERE modalidad = 'Chirigota';
             
        SELECT general_accc.modifica_agrupacionanio (auxInt1, auxInt2, null, null, null, auxInt3, null, null, 12, null, 'Peña', null, null, false, '', null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT agrupacion_anio INTO auxChar1 FROM general_accc.agrupacion_anio WHERE id = auxInt2;
        RAISE NOTICE '    Valor actual del registro con id %: %', auxInt2, auxChar1;
    END;
    $$;


-- Pruebas tabla usa

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_agrupacion_usa_instrumento correcta';
        SELECT id INTO auxInt1 FROM general_accc.instrumento WHERE instrumento = 'Pito de caña';
        SELECT id INTO auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre'; 
        
        SELECT general_accc.alta_agrupacion_usa_instrumento (auxInt1, auxInt2, 10) INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_agrupacion_usa_instrumento correcta, otro';
        SELECT id INTO auxInt1 FROM general_accc.instrumento WHERE instrumento = 'Guitarra';
        
        SELECT general_accc.alta_agrupacion_usa_instrumento (auxInt1, auxInt2, 3) INTO salida;
        RAISE NOTICE '%', salida;

        SELECT nombre || ', ' || categoria || ', ' || modalidad || ', ' ||  COALESCE(total_instrumento,'0')
            INTO auxChar1
            FROM general_accc."Agrupacion_AgrupacionAnio_Instrumentos"
            WHERE nombre = 'En las mismas de siempre';
        RAISE NOTICE '    Valor actual del registro con id %: %', auxInt2, auxChar1;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_agrupacion_usa_instrumento incorrecta, modificando la agrupación';
        SELECT id INTO auxInt1 FROM general_accc.instrumento WHERE instrumento = 'Pito de caña';
        SELECT id INTO auxInt2 FROM general_accc.agrupacion_anio LIMIT 1; 

        SELECT id INTO auxInt3
            FROM general_accc.usa
            WHERE instrumento = auxInt1
            ORDER BY id ASC
            LIMIT 1;
            
        SELECT general_accc.modifica_agrupacion_usa_instrumento (auxInt3, auxInt1, auxInt1, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_agrupacion_usa_instrumento correcta';
        SELECT id INTO auxInt1 FROM general_accc.instrumento WHERE instrumento = 'Pito de caña';
        SELECT id INTO auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre'; 

        SELECT id INTO auxInt3 FROM general_accc.usa
            WHERE instrumento = auxInt1 AND agrupacion_anio = auxInt2
            ORDER BY id ASC
            LIMIT 1;
            
        SELECT id INTO auxInt1 FROM general_accc.instrumento WHERE instrumento = 'Caja';
            
        SELECT general_accc.modifica_agrupacion_usa_instrumento (auxInt3, auxInt1, auxInt2, 3) INTO salida;
        RAISE NOTICE '%', salida;

        SELECT nombre || ', ' || categoria || ', ' || modalidad || ', ' || COALESCE(total_instrumento,'0')
            INTO auxChar1
            FROM general_accc."Agrupacion_AgrupacionAnio_Instrumentos"
            WHERE nombre = 'En las mismas de siempre';
        RAISE NOTICE '    Valor actual del registro con id %: %', auxInt2, auxChar1;
    END;
    $$;


-- ~ -- Prueba de función auxiliar

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_id_agrupacionanio correcta';
        SELECT id INTO auxInt1 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre'; 
            
        SELECT general_accc.modifica_id_agrupacionanio (99998, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;

        SELECT nombre || ', ' || categoria || ', ' || modalidad || ', ' || COALESCE(total_instrumento,'0')
            INTO auxChar1
            FROM general_accc."Agrupacion_AgrupacionAnio_Instrumentos"
            WHERE nombre = 'En las mismas de siempre';
        RAISE NOTICE '    Valor actual del registro con id %: %', 99998, auxChar1;
    END;
    $$;
    
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_agrupacion_usa_instrumento completa';
           
        SELECT id INTO auxInt1 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre'; 
        FOR auxRecord IN (SELECT id, instrumento, agrupacion_anio 
                              FROM general_accc.usa
                              WHERE agrupacion_anio = auxInt1)
        LOOP
            
            SELECT general_accc.baja_agrupacion_usa_instrumento (auxRecord.id, auxRecord.instrumento, auxRecord.agrupacion_anio) INTO salida;
            RAISE NOTICE '%', salida;
        END LOOP;

        SELECT nombre || ', ' || categoria || ', ' || modalidad || ', ' ||  COALESCE(total_instrumento,'0')
            INTO auxChar1
            FROM general_accc."Agrupacion_AgrupacionAnio_Instrumentos"
            WHERE nombre = 'En las mismas de siempre';
        RAISE NOTICE '    Valor actual del registro con id %: %', auxInt1, auxChar1;

    END;
    $$;




-- Pruebas en tablas rol, cargo, orquesta y voz
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Alta a dos personas para las pruebas';    
        SELECT general_accc.alta_persona ('Antonio', 'Martínez', 'Ares', null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;  
        SELECT general_accc.alta_persona ('Micotondria', 'Cortés', 'Serrano', null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO

    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_cargo_agrupacionanio correcta'; 
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Antonio' AND apellido1 = 'Martínez' AND apellido2 = 'Ares';
        SELECT id INTO auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
        SELECT general_accc.alta_cargo_agrupacionanio (auxInt1,auxInt2,'Director',null) INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_cargo_agrupacionanio correcta, misma persona con otro cargo';
        SELECT general_accc.alta_cargo_agrupacionanio (auxInt1,auxInt2,'Representante legal',null) INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_voz_agrupacionanio correcta, persona anterior puede cantar';
        SELECT general_accc.alta_voz_agrupacionanio (auxInt1,auxInt2,'Octavilla') INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_orquesta_agrupacionanio incorrecta, rol de orquesta a la persona anterior';
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Antonio' AND apellido1 = 'Martínez' AND apellido2 = 'Ares';
        SELECT id INTO auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
        SELECT id INTO auxInt3 FROM general_accc.instrumento WHERE instrumento = 'Guitarra';
        SELECT general_accc.alta_orquesta_agrupacionanio (auxInt1,auxInt2,auxInt3) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO

    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_cargo_agrupacionanio incorrecta, segundo director a la agrupación';
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Micotondria' AND apellido1 = 'Cortés' AND apellido2 = 'Serrano';
        SELECT id INTO auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
        SELECT general_accc.alta_cargo_agrupacionanio (auxInt1,auxInt2,'Director',null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO

    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxRecord record;
    BEGIN
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_orquesta_agrupacionanio correcta, otra persona en rol de orquesta';
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Micotondria' AND apellido1 = 'Cortés' AND apellido2 = 'Serrano';
        SELECT id INTO auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
        SELECT id INTO auxInt3 FROM general_accc.instrumento WHERE instrumento = 'Guitarra';
        SELECT general_accc.alta_orquesta_agrupacionanio (auxInt1,auxInt2,auxInt3) INTO salida;
        RAISE NOTICE '%', salida;

        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Roles en la agrupación';
        FOR auxRecord IN (SELECT agrupacion, rol, nombre, apellido1, apellido2
                              FROM general_accc."AgrupacionAnio_Roles"
                              WHERE agrupacion = 'En las mismas de siempre')
        LOOP
            RAISE NOTICE '    %', auxRecord;
        END LOOP;

        
    END;
    $$;
DO

    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxInt4 integer;
        auxRecord record;
    BEGIN
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_orquesta_agrupacionanio correcta';
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Micotondria' AND apellido1 = 'Cortés' AND apellido2 = 'Serrano';
        SELECT id INTO auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
        SELECT id INTO auxInt3 FROM general_accc.instrumento WHERE instrumento = 'Pito de caña';  
        SELECT orquesta.rol INTO auxInt4
            FROM general_accc.orquesta
            INNER JOIN general_accc.rol
                ON rol.id = orquesta.rol
            WHERE persona = auxInt1 AND agrupacion_anio = auxInt2;        
        SELECT general_accc.modifica_orquesta_agrupacionanio (auxInt4,auxInt1,auxInt2,auxInt3) INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_voz_agrupacionanio correcta';
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Antonio' AND apellido1 = 'Martínez' AND apellido2 = 'Ares';   
        SELECT voz.rol INTO auxInt3
            FROM general_accc.voz
            INNER JOIN general_accc.rol
                ON rol.id = voz.rol
            WHERE persona = auxInt1 AND agrupacion_anio = auxInt2;  
        SELECT general_accc.modifica_voz_agrupacionanio (auxInt3,auxInt1,auxInt2,'Barítono') INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_cargo_agrupacionanio correcta';
        SELECT cargo.id, rol.id INTO auxInt3,auxInt4
            FROM general_accc.cargo
            INNER JOIN general_accc.rol
                ON rol.id = cargo.rol
            WHERE tipo_cargo::character varying = 'Representante legal'
                AND persona = auxInt1 AND agrupacion_anio = auxInt2;           
        SELECT general_accc.modifica_cargo_agrupacionanio (auxInt3,auxInt4,auxInt1,auxInt2,'Postulante','modificado') INTO salida;
        RAISE NOTICE '%', salida;

        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Roles modificados en la agrupación';
        FOR auxRecord IN (SELECT agrupacion, rol, nombre, apellido1, apellido2
                              FROM general_accc."AgrupacionAnio_Roles"
                              WHERE agrupacion_anio = 'En las mismas de siempre')
        LOOP
            RAISE NOTICE '    %', auxRecord;
        END LOOP;

        
    END;
    $$;



-- Pruebas en la tabla participa

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Alta a dos concursos para las pruebas';        
        SELECT general_accc.alta_concurso (2011, 'COAC - Junior', 'Localidad 1', 'Provincia 1', 'Ubicación 1', null, 'Junior') INTO salida;
        RAISE NOTICE '%', salida;        
        SELECT general_accc.alta_concurso (2011, 'COAC', 'Localidad 1', 'Provincia 1', 'Ubicación 1', null, 'Adultos') INTO salida;
        RAISE NOTICE '%', salida;          
        SELECT id INTO auxInt1 FROM general_accc.evento WHERE anio = 2011 AND nombre = 'COAC' AND localidad = 'Localidad 1';
        SELECT id INTO auxInt2 FROM general_accc.modalidad WHERE modalidad = 'Comparsa'; 
        SELECT general_accc.alta_premio_concurso (auxInt1, auxInt2, 1, 100.00, 'Por integrante') INTO salida;
        RAISE NOTICE '%', salida;  
        SELECT general_accc.alta_premio_concurso (auxInt1, auxInt2, 2, 50.00, 'Por integrante') INTO salida;
        RAISE NOTICE '%', salida;    
        SELECT general_accc.alta_premio_concurso (auxInt1, auxInt2, 3, 10.00, 'Por integrante') INTO salida;
        RAISE NOTICE '%', salida;    
        SELECT id INTO auxInt2 FROM general_accc.modalidad WHERE modalidad = 'Chirigota'; 
        SELECT general_accc.alta_premio_concurso (auxInt1, auxInt2, 1, 100.00, 'Por integrante') INTO salida;
        RAISE NOTICE '%', salida;
        SELECT general_accc.alta_premio_concurso (auxInt1, auxInt2, 2, 50.00, 'Por integrante') INTO salida;
        RAISE NOTICE '%', salida;    
        SELECT general_accc.alta_premio_concurso (auxInt1, auxInt2, 3, 10.00, 'Por integrante') INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_participa correcta';
        SELECT id INTO auxInt1 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
        SELECT id INTO auxInt2 FROM general_accc.evento
            INNER JOIN  general_accc.concurso
                ON evento.id = concurso.evento
            WHERE anio = 2011 AND nombre = 'COAC' AND localidad = 'Localidad 1' AND categoria::character varying = 'Adultos';
        
        SELECT general_accc.alta_participa (auxInt1, auxInt2, 2, 168, 'final') INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_participa correcta';
        SELECT id INTO auxInt1 FROM general_accc.agrupacion_anio WHERE nombre = 'Cogehlo ahí'; 
        SELECT id INTO auxInt2 FROM general_accc.evento
            INNER JOIN  general_accc.concurso
                ON evento.id = concurso.evento
            WHERE anio = 2011 AND nombre = 'COAC - Junior' AND localidad = 'Localidad 1' AND categoria::character varying = 'Junior';
        
        SELECT general_accc.alta_participa (auxInt1, auxInt2, 2, 168, 'final') INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_participa incorrecta, por el año';
        SELECT id INTO auxInt1 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre'; 
        SELECT id INTO auxInt2 FROM general_accc.evento
            INNER JOIN  general_accc.concurso
                ON evento.id = concurso.evento
            WHERE anio = 2015
            LIMIT 1;
        
        SELECT general_accc.alta_participa (auxInt1, auxInt2, 56, 2, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_participa incorrecta, por la categoría';
              
        SELECT id, entidad INTO auxInt1,auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'Cogehlo ahí';
        
        SELECT id INTO auxInt2 FROM general_accc.evento
            INNER JOIN general_accc.concurso
                ON evento.id = concurso.evento
            WHERE anio = 2011 AND nombre = 'COAC' AND localidad = 'Localidad 1' AND categoria::character varying = 'Adultos';      
        SELECT general_accc.alta_participa (auxInt1, auxInt2, 10, 168, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxInt4 integer;
        auxEnum general_accc.enum_categoria;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_participa incorrecta, porque el premio ya está dado';
        SELECT id, anio, modalidad, categoria
                INTO auxInt1,auxInt2,auxInt3,auxEnum
            FROM general_accc.agrupacion_anio
            WHERE nombre = 'En las mismas de siempre'; 
        SELECT id INTO auxInt1
            FROM general_accc.agrupacion_anio
            WHERE anio = auxInt2
                AND modalidad = auxInt3
                AND categoria = auxEnum
                AND id <> auxInt1
            LIMIT 1; 
        SELECT id INTO auxInt2 FROM general_accc.evento
            INNER JOIN  general_accc.concurso
                ON evento.id = concurso.evento
            WHERE anio = 2011 AND nombre = 'COAC' AND localidad = 'Localidad 1' AND categoria::character varying = 'Adultos';
        
        SELECT general_accc.alta_participa (auxInt1, auxInt2, 2, 168, 'final') INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxInt4 integer;
        auxEnum general_accc.enum_categoria;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_participa incorrecta, intento de modificar la agrupación';
        SELECT id, anio, modalidad, categoria
                INTO auxInt1,auxInt2,auxInt3,auxEnum
            FROM general_accc.agrupacion_anio
            WHERE nombre =  'En las mismas de siempre'; 
        SELECT id INTO auxInt1
            FROM general_accc.agrupacion_anio
            WHERE anio = auxInt2
                AND modalidad = auxInt3
                AND categoria = auxEnum
                AND id <>
            LIMIT 1; 
        SELECT id INTO auxInt2 FROM general_accc.evento
            INNER JOIN  general_accc.concurso
                ON evento.id = concurso.evento
            WHERE anio = 2011 AND nombre = 'COAC' AND localidad = 'Localidad 1' AND categoria::character varying = 'Adultos';
        SELECT general_accc.modifica_participa (auxInt1, auxInt2, 2, 168, 'final') INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_agrupacionanio incorrecta, intentando cambiar la categoría';
               
        SELECT entidad, id INTO auxInt1,auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
             
        SELECT general_accc.modifica_agrupacionanio (auxInt1, auxInt2, null, null, 'Junior', null, null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_agrupacionanio incorrecta, intentando cambiar el año';
               
        SELECT entidad, id INTO auxInt1,auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
             
        SELECT general_accc.modifica_agrupacionanio (auxInt1, auxInt2, null, 2013, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_concurso incorrecta, intentando cambiar la categoría';
        SELECT id INTO auxInt1 FROM general_accc.evento
            INNER JOIN  general_accc.concurso
                ON evento.id = concurso.evento
            WHERE anio = 2011 AND nombre = 'COAC' AND localidad = 'Localidad 1' AND categoria::character varying = 'Adultos';
        SELECT general_accc.modifica_concurso (auxInt1, null, null, null, null, null, null, 'Infantil') INTO salida;
        RAISE NOTICE '    %', salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxInt4 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_premio incorrecta, intentando cambiar la modalidad';
                       
        SELECT id, modalidad INTO auxInt1, auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
                       
        SELECT id INTO auxInt4 FROM general_accc.agrupacion_anio WHERE id <> auxInt2 LIMIT 1;
        SELECT premio.id, concurso.evento INTO auxInt2, auxInt3
            FROM general_accc.concurso
            INNER JOIN general_accc.premio
                ON concurso.evento = premio.concurso
            INNER JOIN general_accc.participa
                ON concurso.evento = participa.concurso
            WHERE participa.agrupacion_anio = auxInt1;
        SELECT general_accc.modifica_premio_concurso (auxInt2, auxInt3, auxInt4, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;



-- Bloques de eliminación de registros de prueba

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_participa correcta';
        SELECT id INTO auxInt1 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre'; 
        SELECT id INTO auxInt2 FROM general_accc.evento
            INNER JOIN  general_accc.concurso
                ON evento.id = concurso.evento
            WHERE anio = 2011 AND nombre = 'COAC' AND localidad = 'Localidad 1' AND categoria::character varying = 'Adultos';
        
        SELECT general_accc.baja_participa (auxInt1, auxInt2) INTO salida;
        RAISE NOTICE '%', salida;
        
        SELECT id INTO auxInt1 FROM general_accc.agrupacion_anio WHERE nombre = 'Cogehlo ahí'; 
        SELECT id INTO auxInt2 FROM general_accc.evento
            INNER JOIN  general_accc.concurso
                ON evento.id = concurso.evento
            WHERE anio = 2011 AND nombre = 'COAC - Junior' AND localidad = 'Localidad 1' AND categoria::character varying = 'Junior';
        
        SELECT general_accc.baja_participa (auxInt1, auxInt2) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
    
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Eliminación de concursos de prueba';
        
        SELECT id INTO auxInt1 FROM general_accc.evento
            INNER JOIN  general_accc.concurso
                ON evento.id = concurso.evento
            WHERE anio = 2011 AND nombre = 'COAC' AND localidad = 'Localidad 1' AND categoria::character varying = 'Adultos';
        FOR auxRecord IN (SELECT id 
                              FROM general_accc.premio
                              WHERE concurso = auxInt1)
        LOOP            
            SELECT general_accc.baja_premio_concurso (auxInt1, auxRecord.id) INTO salida;
            RAISE NOTICE '    Baja premio id %: %', auxRecord.id, salida;
        END LOOP;
                 
        SELECT general_accc.baja_concurso (auxInt1) INTO salida;
        RAISE NOTICE '    Baja concurso id %: %', auxInt1, salida;

                 
        SELECT id INTO auxInt1 FROM general_accc.evento
            INNER JOIN  general_accc.concurso
                ON evento.id = concurso.evento
            WHERE anio = 2011 AND nombre = 'COAC - Junior' AND localidad = 'Localidad 1' AND categoria::character varying = 'Junior';
        FOR auxRecord IN (SELECT id 
                              FROM general_accc.premio
                              WHERE concurso = auxInt1)
        LOOP            
            SELECT general_accc.baja_premio_concurso (auxInt1, auxRecord.id) INTO salida;
            RAISE NOTICE '    Baja premio id %: %', auxRecord.id, salida;
        END LOOP;
        
        SELECT general_accc.baja_concurso (auxInt1) INTO salida;
        RAISE NOTICE '    Baja concurso id %: %', auxInt1, salida;
    
    END;
    $$;


DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxRecord record;
        auxRecord2 record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_orquesta_agrupacionanio, baja_voz_agrupacionanio y baja_cargo_agrupacionanio';
        
        SELECT id INTO auxInt1 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
        
        FOR auxRecord IN (SELECT id, persona, agrupacion_anio, tipo_rol
                              FROM general_accc.rol
                              WHERE agrupacion_anio = auxInt1)
        LOOP
            IF auxRecord.tipo_rol::character varying = 'Orquesta' THEN
                SELECT general_accc.baja_orquesta_agrupacionanio (auxRecord.id, auxRecord.persona, auxRecord.agrupacion_anio) INTO salida;
                RAISE NOTICE '    Baja rol tipo %: %', auxRecord.tipo_rol, salida;
                
            ELSEIF auxRecord.tipo_rol::character varying = 'Voz' THEN
                SELECT general_accc.baja_voz_agrupacionanio (auxRecord.id, auxRecord.persona, auxRecord.agrupacion_anio) INTO salida;
                RAISE NOTICE '    Baja rol tipo %: %', auxRecord.tipo_rol, salida;
                
            ELSEIF auxRecord.tipo_rol::character varying = 'Cargo' THEN
                FOR auxRecord2 IN (SELECT id, rol, tipo_cargo
                                       FROM general_accc.cargo
                                       WHERE rol = auxRecord.id)
                LOOP
                    SELECT general_accc.baja_cargo_agrupacionanio (auxRecord2.id, auxRecord2.rol, auxRecord.persona, auxRecord.agrupacion_anio) INTO salida;
                    RAISE NOTICE '    Baja rol tipo Cargo, %: %', auxRecord2.tipo_cargo, salida;
                END LOOP;
            END IF;
        END LOOP;
    
    END;
    $$;


DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        
        RAISE NOTICE 'Baja a personas de prueba';
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Antonio' AND apellido1 = 'Martínez' AND apellido2 = 'Ares';        
        SELECT general_accc.baja_persona (auxInt1) INTO salida;      
        RAISE NOTICE '%', salida;
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Micotondria' AND apellido1 = 'Cortés' AND apellido2 = 'Serrano';
        SELECT general_accc.baja_persona (auxInt1) INTO salida;      
        RAISE NOTICE '%', salida;
    
    END;
    $$;


DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_agrupacionanio correcta';    
 
        SELECT entidad INTO auxInt1 FROM general_accc.agrupacion ORDER BY entidad ASC LIMIT 1;
        SELECT id INTO auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'Cogehlo ahí';
             
        SELECT general_accc.baja_agrupacionanio (auxInt1, auxInt2) INTO salida;
        RAISE NOTICE '    Baja AgrupacionAnio: %', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_agrupacionanio correcta, borrará agrupación de nivel superior';  
        SELECT entidad, id INTO auxInt1, auxInt2 FROM general_accc.agrupacion_anio
            WHERE nombre = 'En las mismas de siempre';
        SELECT general_accc.baja_agrupacionanio (auxInt1, auxInt2) INTO salida;
        RAISE NOTICE '    Baja AgrupacionAnio: %', salida;
        
        SELECT agrupacion INTO salida FROM general_accc.agrupacion
            WHERE localidad = 'Localidad Agrupacion'
                AND provincia = 'Provincia Agrupacion';
        RAISE NOTICE '    Valor de la agrupación que se le creó: %', salida;
        
    END;
    $$;







-- Declaración de funciones utilizadas


-- general_accc.__verifica_agrupacionanio_obra (in_tipo_obra, in_nombre_agrupacion, in_obra)

-- -- general_accc.alta_agrupacionanio (in_entidad, in_id, in_localidad, in_provincia, in_nombre, in_anio, in_categoria, in_modalidad, in_submodalidad, in_composicion, in_num_componentes, in_presupuesto, in_lugar_ensayo, in_observaciones, in_en_prensa, in_en_documento_oficial, in_fuentes, in_observaciones_gestion, in_interpreta_literaria, in_interpreta_musical, in_utiliza_tipo)

-- general_accc.modifica_agrupacionanio (in_entidad, in_id, in_nombre, in_anio, in_categoria, in_modalidad, in_submodalidad, in_composicion, in_num_componentes, in_presupuesto, in_lugar_ensayo, in_observaciones, in_en_prensa, in_en_documento_oficial, in_fuentes, in_observaciones_gestion, in_interpreta_literaria, in_interpreta_musical, in_utiliza_tipo)

-- general_accc.modifica_id_agrupacionanio (in_id_nuevo, in_id_viejo)

-- general_accc.baja_agrupacionanio (in_entidad, in_id)

-- general_accc.baja_literaria_agrupacionanio (in_entidad, in_id)

-- general_accc.baja_musical_agrupacionanio (in_entidad, in_id)

-- general_accc.baja_tipo_agrupacionanio (in_entidad, in_id)

-- general_accc.alta_agrupacion_usa_instrumento (in_instrumento, in_agrupacion_anio, in_total)

-- general_accc.modifica_agrupacion_usa_instrumento (in_id, in_instrumento, in_agrupacion_anio, in_total)

-- general_accc.baja_agrupacion_usa_instrumento (in_id, in_instrumento, in_agrupacion_anio)

-- general_accc.__alta_rol (in_id, in_persona, in_agrupacion_anio, in_tipo_rol)

-- general_accc.alta_cargo_agrupacionanio (in_persona, in_agrupacion_anio, in_tipo_cargo, in_observaciones)

-- general_accc.modifica_cargo_agrupacionanio (in_id, in_rol, in_persona, in_agrupacion_anio, in_tipo_cargo, in_observaciones)

-- general_accc.baja_cargo_agrupacionanio (in_id, in_rol, in_persona, in_agrupacion_anio)

-- general_accc.alta_orquesta_agrupacionanio (in_persona, in_agrupacion_anio, in_instrumento)

-- general_accc.modifica_orquesta_agrupacionanio (in_rol, in_persona, in_agrupacion_anio, in_instrumento)

-- general_accc.baja_orquesta_agrupacionanio (in_rol, in_persona, in_agrupacion_anio)

-- general_accc.alta_voz_agrupacionanio (in_persona, in_agrupacion_anio, in_tipo_voz)

-- general_accc.modifica_voz_agrupacionanio (in_rol, in_persona, in_agrupacion_anio, in_tipo_voz)

-- general_accc.baja_voz_agrupacionanio (in_rol, in_persona, in_agrupacion_anio)

-- general_accc.alta_participa (in_agrupacion_anio, in_concurso, in_clasificacion, in_puntos, in_fase)

-- general_accc.modifica_participa (in_agrupacion_anio, in_concurso, in_clasificacion, in_puntos, in_fase)

-- general_accc.baja_participa (in_agrupacion_anio, in_concurso)


