--------------------------------------------------------------------------------
--                 Pruebas a los SP en 062_SP_ObraMusical.sql                 --
--------------------------------------------------------------------------------



-- Pruebas en la tabla musical, obra y documento_obra
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_musical correcta, sin indicar el identificador del documento ES.ACCC//2'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.alta_musical (2, 'Presentación, pasodoble, cuplé y popurrí', 400, 'ES.ACCC//2', 'En las mismas de siempre', '2011', 'Imagen', 'No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba doc_nuevo_a_musical correcta'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.doc_nuevo_a_musical (2, 500, null, 'Registro en Depósito legal', '2011', 'Texto', 'Papel', null, null, null, '/Datos/2-500-DL.pdf', 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, true, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO salida FROM general_accc.documento WHERE id = 500;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba de vinculación a agrupación correcta';
  
        SELECT id INTO auxInt1 FROM general_accc.modalidad WHERE modalidad = 'Comparsa';
        SELECT general_accc.alta_agrupacionanio (null, null, 'Localidad Agrupacion', 'Provincia Agrupacion', 'En las mismas de siempre', 2011, 'Adultos', auxInt1, null, 'Masculina', 15, null, null, null, null, true, 'Prensa', null, null, null, null) INTO salida;       

        SELECT entidad,id INTO auxInt1, auxInt2 FROM general_accc.agrupacion_anio WHERE nombre = 'En las mismas de siempre';
        
        SELECT general_accc.modifica_agrupacionanio (auxInt1, auxInt2,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,2,null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba doc_nuevo_a_musical correcta, tras vincular la agrupación'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.doc_nuevo_a_musical (2, 600, null, 'Actuación en la Peña la Estrella', '2011', 'Video', 'VHS', null, null, null, '/Datos/2-600-PeñaLaEstrella.avi', 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, true, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO salida FROM general_accc.documento WHERE id = 600;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba doc_existente_a_literaria, de tipo vídeo';    
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.alta_literaria (11, 'Presentación, 10 pasodobles, 8 cuplés y popurrí', 101, 'ES.ACCC//11', 'En las mismas de siempre', '2011', 'Texto', 'No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        SELECT general_accc.doc_existente_a_literaria (11, 600) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_musical correcta, cambio de título al que no lo contiene';
  
        SELECT general_accc.modifica_musical (2, null, 500, null, 'Actuación en semifinales', null, 'Audio', 'Casete', null, null, null, '/Datos/2-500-SemifinalCOAC.wav', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO salida FROM general_accc.documento WHERE id = 500;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_musical incorrecta, cambio de título al único que lo contiene';
  
        SELECT general_accc.modifica_musical (2, null, 400, null, 'Erróneo', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;



-- Bloques de eliminación de registros de prueba

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_documento_musical del documento asociado a la literaria, el cual sigue existiendo';    
        SELECT general_accc.baja_documento_musical (600, 2) INTO salida;
        RAISE NOTICE '    Baja en musical: %', salida;
        SELECT documento INTO salida FROM general_accc.documento WHERE id = 600;
        RAISE NOTICE '%', salida;
        SELECT COUNT(documento_obra) INTO salida
            FROM general_accc.documento_obra
            WHERE documento = 600;
        RAISE NOTICE '    Consulta en documento_obra del total de ocurrencias: %', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        SELECT entidad, id INTO auxInt1, auxInt2 FROM general_accc.agrupacion_anio
            WHERE nombre = 'En las mismas de siempre';
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_musical_agrupacionanio correcta';  
        SELECT general_accc.baja_musical_agrupacionanio (auxInt1, auxInt2) INTO salida;
        RAISE NOTICE '    Baja obra musical: %', salida;
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_agrupacionanio correcta, borrará agrupación de nivel superior';        
                    SELECT general_accc.baja_agrupacionanio (auxInt1, auxInt2) INTO salida;
                    RAISE NOTICE '    Baja AgrupacionAnio: %', salida;
                    
                    SELECT agrupacion INTO salida FROM general_accc.agrupacion
                        WHERE localidad = 'Localidad Agrupacion'
                            AND provincia = 'Provincia Agrupacion';
                    RAISE NOTICE '    Valor de la agrupación que se le creó: %', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_documento_musical correcta'; 
        SELECT general_accc.__modifica_documento (500, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        SELECT general_accc.baja_documento_musical (500, 2) INTO salida;
        RAISE NOTICE '    %', salida;
        
        SELECT general_accc.__modifica_documento (400, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        RAISE NOTICE 'Prueba baja_musical correcta';
        SELECT general_accc.baja_musical (2, 400) INTO salida;
        RAISE NOTICE '    %', salida;
        
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Baja a la literaria de pruebas'; 
        SELECT general_accc.__modifica_documento (600, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        SELECT general_accc.baja_documento_literaria (600, 11) INTO salida;
        RAISE NOTICE '     %', salida;        
        RAISE NOTICE '     Se utiliza baja_literaria respecto a esto último';
        SELECT general_accc.baja_literaria (11, 101) INTO salida;
        RAISE NOTICE '     %', salida;
    END;
    $$;

 


-- Declaración de funciones utilizadas

-- general_accc.alta_musical (in_signatura_obra, in_repertorio, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_descriptor, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.modifica_musical (in_signatura_obra, in_repertorio, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.baja_musical (in_signatura_obra, in_documento)

-- general_accc.modifica_signatura_musical (in_signatura_nueva, in_signatura_vieja)

-- general_accc.doc_nuevo_a_musical (in_signatura_obra, in_id_doc,	in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_descriptor, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.doc_existente_a_musical (in_documento, in_obra_musical)

-- general_accc.baja_documento_musical (in_documento, in_obra_musical)
