--------------------------------------------------------------------------------
--                  Pruebas a los SP en 072_SP_Musica.sql                     --
--------------------------------------------------------------------------------



-- Pruebas en la tabla musica y documento_musica

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Creación de obra musical para pruebas'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;       
        SELECT general_accc.alta_musical (23, 'Presentación, pasodoble, cuplé y popurrí', 123, null, 'La Eternidad', '2011', 'Audio', 'No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_musica correcta, debe asignarse la signatura dentro de la obra automáticamente'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1; 
        SELECT general_accc.alta_musica (23,null,auxInt2,'Pasodoble',null, null,'Partitura pasodoble','2017','Imagen','No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_musica correcta, se indica la signatura y no el documento'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1;
        SELECT general_accc.alta_musica (23,30,auxInt2,'Presentación',1030, null,'Partitura presentación','2017','Imagen','No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_musica incorrecta, por el nivel de descripcion'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1; 
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1; 
        SELECT general_accc.alta_musica (23,null,auxInt2,'Popurrí',null, null,'Erróneo','2017','Imagen','No disponible', null, null, null, null, 'Unidad documental compuesta', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_musica incorrecta, por ser el segundo componente de género Pasodoble'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1; 
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1; 
        SELECT general_accc.alta_musica (23,null,auxInt2,'Pasodoble',null, null,'Partitura pasodoble','2017','Imagen','No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;


DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba doc_nuevo_a_musica correcta'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;  
        SELECT id INTO auxInt2 FROM general_accc.musica where obra_musical = 23 AND signatura = 30;       
        SELECT general_accc.doc_nuevo_a_musica (auxInt2, 23, 30, 1031, null, 'Actuación en COAC, Coplas Eternas', '2011', 'Audio', 'Electrónico', null, null, null, '/Datos/1-1031-ActuacionCOAC-P8.mp3', 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, true, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT documento INTO salida FROM general_accc.documento WHERE id = 1031;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_musica correcta'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1; 
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1; 
        SELECT general_accc.alta_musica (23,null,auxInt2,'Cuplé', 1032, null,'Actuación en COAC, Coplas Eternas','2017','Audio','No disponible', null, null, null, null, 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxRecord record;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_musica correcta, se indica el documento'; 
        SELECT id INTO auxInt1 FROM general_accc.descriptor LIMIT 1;
        SELECT entidad INTO auxInt2 FROM general_accc.persona LIMIT 1;  
        SELECT general_accc.alta_musica (23,null,auxInt2,'Popurrí',1033, null,'Partitura popurrí','2017','Imagen','Electrónico', null, null, null, 'A1', 'Unidad documental simple', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, auxInt1, true, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;

        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Signaturas asignadas automáticamente'; 
        
        FOR auxRecord IN (SELECT doc.id, signatura, "3_1_1_codigo_referencia"
                              FROM general_accc.documento_musica AS d_l
                              INNER JOIN general_accc.documento AS doc
                                  ON d_l.documento = doc.id
                              INNER JOIN general_accc.musica
                                  ON d_l.musica = musica.id
                              WHERE musica.obra_musical = 23)
        LOOP
            RAISE NOTICE '    Documento, Signatura, Código de Referencia: %', auxRecord;
        END LOOP;
        
    END;
    $$;

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN
    
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba modifica_signatura_literaria, aún no realizada por resultar más evidente en caso de existir varios documentos';  
        SELECT general_accc.modifica_signatura_musical (230,23) INTO salida;
        RAISE NOTICE 'Signaturas tras la modificación'; 
        
        FOR auxRecord IN (SELECT doc.id, signatura, "3_1_1_codigo_referencia"
                              FROM general_accc.documento_musica AS d_l
                              INNER JOIN general_accc.documento AS doc
                                  ON d_l.documento = doc.id
                              INNER JOIN general_accc.musica
                                  ON d_l.musica = musica.id
                              WHERE musica.obra_musical = 230)
        LOOP
            RAISE NOTICE '    Documento, Signatura, Código de Referencia: %', auxRecord;
        END LOOP;
        
    END;
    $$;
    





-- ~ -- Bloques de eliminación de registros de prueba

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
       
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_documento_musica incorrecta, el documento no tiene más vínculos dentro de la BBDD y es tangible';  
        SELECT id INTO auxInt1 FROM general_accc.musica where obra_musical = 23 AND signatura = 30; 
        SELECT general_accc.baja_documento_musica (1031, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxChar2 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
       
        RAISE NOTICE ' ';
        RAISE NOTICE ' ';   
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_documento_musica correcta, es el penúltimo asociado';
        
        SELECT id INTO auxInt1 FROM general_accc.musica where obra_musical = 23 AND signatura = 30;  

        SELECT general_accc.baja_documento_musica (1030, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        
    END;
    $$;
    
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Baja al resto de musicas creadas';
        
        SELECT musica.id, musica.signatura INTO auxInt1, auxInt2
            FROM general_accc.musica
            INNER JOIN general_accc.documento_musica AS d_l
                ON musica.id = d_l.musica
            WHERE obra_musical = 23
                AND documento = 1031;  
        SELECT general_accc.__modifica_documento (1031, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        SELECT general_accc.baja_musica (auxInt1, 23, auxInt2, 1031) INTO salida;
        RAISE NOTICE '    Documento 1031: %', salida;
        
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN 
        SELECT musica.id, musica.signatura INTO auxInt1, auxInt2
            FROM general_accc.musica
            INNER JOIN general_accc.documento_musica AS d_l
                ON musica.id = d_l.musica
            WHERE obra_musical = 23
                AND documento = 1032;    
        SELECT general_accc.__modifica_documento (1032, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        SELECT general_accc.baja_musica (auxInt1, 23, auxInt2, 1032) INTO salida;
        RAISE NOTICE '    Documento 1032: %', salida;
        
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN  
        SELECT musica.id, musica.signatura INTO auxInt1, auxInt2
            FROM general_accc.musica
            INNER JOIN general_accc.documento_musica AS d_l
                ON musica.id = d_l.musica
            WHERE obra_musical = 23
                AND documento = 1033;   
        SELECT general_accc.__modifica_documento (1033, null, null, null, null, 'No disponible', null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, false, false, null) INTO salida;
        SELECT general_accc.baja_musica (auxInt1, 23, auxInt2, 1033) INTO salida;
        RAISE NOTICE '    Documento 1033: %', salida;
        
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_musica respecto a la primera, donde no se indicao el documento ni la signatura';
        SELECT musica.id, musica.signatura, d_l.documento  INTO auxInt1, auxInt2, auxInt3
            FROM general_accc.musica
            INNER JOIN general_accc.documento_musica AS d_l
                ON musica.id = d_l.musica
            WHERE obra_musical = 23;  
        SELECT general_accc.baja_musica (auxInt1, 23, auxInt2, auxInt3) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba baja_musical correcta';
        SELECT general_accc.baja_musical (23, 123) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

 

 


-- Declaración de funciones utilizadas

-- general_accc.alta_musica (in_signatura_musical, in_signatura_musica, in_autoria_musica, in_genero, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_descriptor, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.modifica_musica (in_id_musica, in_signatura_musical, in_signatura_musica, in_autoria_musica, in_genero, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

-- general_accc.baja_musica (in_id_musica, in_signatura_musical, in_signatura_musica, in_id_doc)

-- general_accc.__alta_documento_musica (in_documento, in_musica)

-- general_accc.doc_existente_a_musica (in_documento, in_musica)

-- general_accc.baja_documento_musica (in_documento, in_musica)

-- general_accc.doc_nuevo_a_musica (in_id_musica, in_signatura_musical, in_signatura_musica, in_id_doc, in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento, in_tipo_soporte, in_ubicacion, in_deposito, in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3, in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3, in_descriptor, in_esta_descrito, in_esta_digitalizado, in_en_deposito, in_observaciones_gestion)

